api/urls.py
from django.urls import path
from . import views

app_name = 'api'
urlpatterns = [
    # jwt auth
    path('auth/token-pair/', views.CustomTokenViewBase.as_view(), name='token_pair'),
    path('auth/token-refresh/', views.CustomTokenRefreshView.as_view(), name='token_refresh'),
    # views
    path('budget_entries/', views.BudgetEntryView.as_view(), name='budget_entries'),
    path('aggr_budgets/', views.AggregateBudgetView.as_view(), name='aggr_budgets'),
    path('charts/', views.ChartView.as_view(), name='charts-api')
]

project/urls.py
from django.contrib import admin
from django.urls import path, include
from .yasg import urlpatterns as doc_urls

urlpatterns = [
    path('admin/', admin.site.urls),
    path('purse/', include('purse.urls')),
    path('auth/', include('users.urls')),
    path('api/', include('api.urls')),
    path('api-auth', include('rest_framework.urls')),
    path('social/', include('social_django.urls', namespace='social'))
]

urlpatterns += doc_urls

purse/urls.py
from django.urls import path
from . import views


app_name = 'purse'

urlpatterns = [
    path('', views.IndexPageView.as_view(), name='index'),  # переделал
    # CRUD
    path('profile/add_operations/', views.AddBudgetEntryView.as_view(), name='add_operations'),  # create
    path('create_expense/', views.AddBudgetEntryExpenseView.as_view(), name='add_expense'),  # create
    path('create_income/', views.AddBudgetEntryIncomeView.as_view(), name='add_income'),  # create
    path('profile/<str:user>/<int:year>/<str:slug>/', views.AggrBudgetDetailView.as_view(), name='budget_detail'),  # read
    path('profile/history/', views.HistoryOperationsView.as_view(), name='history'),  # read
    path('profile/change/<str:pk>/', views.BudgetEntryUpdateView.as_view(), name='change_budget_entry'),  # update
    path('profile/delete_budget_entry/<str:pk>/', views.DeleteBudgetEntryView.as_view(), name='delete_budget_entry'),  # delete
    path('profile/delete_aggr_budget/<str:pk>/', views.DeleteAggregateBudgetView.as_view(), name='delete_aggr_budget'),  # delete
    # charts
    path('profile/charts/', views.ChartsView.as_view(), name='charts'),
    # export data
    path('profile/download/<str:pk>/', views.download, name='download'),
    path('profile/filter/', views.FilterBudgetEntriesView.as_view(), name='filter'),
]

users/urls.py
from django.urls import path
from .views import *


app_name = 'users'

urlpatterns = [
    # Вход/выход с сайта
    path('login/', UserLoginView.as_view(), name='login'),
    path('logout/', UserLogoutView.as_view(), name='logout'),
    # Изменить информацию о себе
    path('profile/change/', UserChangeInfo.as_view(), name='change_profile'),
    # Изменить пароля
    path('profile/password/change/', UserPasswordChangeView.as_view(), name='password_change'),
    # Сброс пароля
    path('password/reset/', UserPasswordResetView.as_view(), name='password_reset'),
    path('password/reset/<uidb64>/<token>/', UserPasswordResetConfirmView.as_view(), name='password_reset_confirm'),
    path('password/reset/done/', UserPasswordResetCompleteView.as_view(), name='password_reset_complete'),
    # Регистрация пользователя на сайте
    path('registration/', UserRegistrationView.as_view(), name='user_registration'),
    path('registration/activate/<str:sign>/', user_activate, name='registration_activate'),
]

users/models.py
from django.core.mail import send_mail
from django.db import models
from django.contrib.auth.models import AbstractBaseUser, PermissionsMixin
from django.utils import timezone
from django.dispatch import Signal


from .managers import CustomUserManager
from .utils import send_activation_notification


# Create your models here.
class CustomUser(AbstractBaseUser, PermissionsMixin):
    username = models.CharField(max_length=155, unique=True, verbose_name='Логин')
    email = models.EmailField(max_length=255, null=True, blank=True, unique=True, verbose_name='Почта')
    phone = models.CharField(max_length=30, null=True, blank=True, verbose_name='Телефон')
    first_name = models.CharField(max_length=155, null=True, blank=True)
    last_name = models.CharField(max_length=155, null=True, blank=True)
    date_of_birth = models.DateField(null=True, blank=True, verbose_name='Дата рождения')

    date_joined = models.DateField(default=timezone.now)
    is_active = models.BooleanField(default=True)
    is_staff = models.BooleanField(default=False)
    is_superuser = models.BooleanField(default=False)

    USERNAME_FIELD = 'username'
    EMAIL_FIELD = 'email'
    REQUIRED_FIELDS = []

    objects = CustomUserManager()

    def get_full_name(self):
        if not (self.first_name and self.last_name):
            return self.username
        else:
            return f'{self.first_name} {self.last_name}'

    def get_short_name(self):
        if not self.first_name:
            return self.email
        else:
            return self.first_name

    def email_user(self, subject, message, from_email=None, **kwargs):
        send_mail(subject, message, from_email, [self.email], **kwargs)

    def __str__(self):
        return self.username

    def __repr__(self):
        return self.username


user_registrated = Signal(providing_args=['instance'])


def user_registrated_dispatcher(sender, **kwargs):
    send_activation_notification(kwargs['instance'])


user_registrated.connect(user_registrated_dispatcher)

# django-sendsms

users/forms.py
from django import forms
from django.contrib.auth.forms import (UserCreationForm, UserChangeForm, AuthenticationForm, PasswordChangeForm,
                                       PasswordResetForm, SetPasswordForm)
from django.contrib.auth import password_validation
from django.contrib.auth.password_validation import (MinimumLengthValidator, get_default_password_validators,
                                                     validate_password)
from django.core import validators
from .models import CustomUser, user_registrated


class CustomUserLoginForm(AuthenticationForm):
    """Форма авторизации пользователя"""
    username = forms.CharField(
        label='Логин/почта',
        widget=forms.TextInput(attrs={'autofocus': True, 'class': 'form-control'})
    )
    password = forms.CharField(
        label='Пароль',
        strip=False,
        widget=forms.PasswordInput(
            attrs={'autocomplete': 'current-password', 'class': 'form-control'})
    )


class CustomUserChangeForm(forms.ModelForm):
    """Форма правки личных данных"""
    email = forms.EmailField(
        required=True,
        widget=forms.EmailInput(attrs={'class': 'form-control'})
    )
    phone = forms.CharField(widget=forms.TextInput(attrs={'id': 'phone', 'placeholder': 'Телефон'}), label='Телефон', required=False)
    first_name = forms.CharField(label='Имя', required=False)
    last_name = forms.CharField(label='Фамилия', required=False)
    date_of_birth = forms.CharField(required=False)

    class Meta:
        model = CustomUser
        fields = ['email', 'first_name', 'last_name', 'phone', 'date_of_birth', 'username']


class CustomUserPasswordChangeForm(PasswordChangeForm):
    """Форма смены пароля"""
    old_password = forms.CharField(
        strip=False,
        widget=forms.PasswordInput(
            attrs={'autocomplete': 'current-password', 'autofocus': True, 'class': 'form-control',
                   'placeholder': 'Старый пароль'},),
        label='Старый пароль'
    )
    new_password1 = forms.CharField(
        widget=forms.PasswordInput(
            attrs={'autocomplete': 'new-password', 'class': 'form-control', 'placeholder': 'Новый пароль'}),
        strip=False,
        help_text=password_validation.password_validators_help_text_html(),
        label='Новый пароль'
    )
    new_password2 = forms.CharField(
        widget=forms.PasswordInput(
            attrs={'autocomplete': 'new-password', 'class': 'form-control', 'placeholder': 'Новый пароль еще раз'}),
        strip=False,
        label='Новый пароль еще раз'
    )


class CustomUserPasswordResetForm(PasswordResetForm):
    email = forms.EmailField(
        max_length=254,
        widget=forms.EmailInput(attrs={'autocomplete': 'email', 'class': 'form-control', 'placeholder': 'Введите адрес электронной почты'})
    )


class CustomUserSetNewPasswordForm(SetPasswordForm):
    new_password1 = forms.CharField(
        widget=forms.PasswordInput(attrs={'autocomplete': 'new-password', 'class': 'form-control', 'placeholder': 'Новый пароль'}),
        strip=False,
        help_text=password_validation.password_validators_help_text_html(),
    )
    new_password2 = forms.CharField(
        strip=False,
        widget=forms.PasswordInput(attrs={'autocomplete': 'new-password', 'class': 'form-control', 'placeholder': 'Новый пароль еще раз'}),
    )


class UserRegistrationForm(forms.ModelForm):
    username = forms.CharField(
        label='Логин',
        widget=forms.TextInput(attrs={'class': 'form-control', 'placeholder': 'Ваш логин'})
    )
    phone = forms.CharField(
        label='Номер телефона',
        widget=forms.TextInput(attrs={'id': 'phone'}),
        required=False
    )
    email = forms.EmailField(
        max_length=254,
        widget=forms.EmailInput(
            attrs={'autocomplete': 'email', 'class': 'form-control', 'placeholder': 'Введите адрес электронной почты'}),
    )
    first_name = forms.CharField(
        max_length=150,
        widget=forms.TextInput(
            attrs={'class': 'form-control', 'placeholder': 'Ваше имя'}
        ),
        required=False,
        label='Имя'
    )
    last_name = forms.CharField(
        max_length=150,
        widget=forms.TextInput(
            attrs={'class': 'form-control', 'placeholder': 'Ваша фамилия'}
        ),
        required=False,
        label='Фамилия'
    )
    password = forms.CharField(
        widget=forms.PasswordInput(
            attrs={'autocomplete': 'new-password', 'class': 'form-control', 'placeholder': 'Пароль'}),
        help_text=password_validation.password_validators_help_text_html(),
        label='Пароль'
    )
    password2 = forms.CharField(
        widget=forms.PasswordInput(
            attrs={'autocomplete': 'new-password', 'class': 'form-control', 'placeholder': 'Подтвердите пароль'}),
        help_text='Введите пароль еще раз для проверки',
        label='Пароль еще раз'
    )

    class Meta:
        model = CustomUser
        fields = ['email', 'first_name', 'last_name', 'phone', 'username']

    def clean_password2(self):
        cd = self.cleaned_data
        if cd['password'] != cd['password2']:
            raise forms.ValidationError('Введенные пароли не совпадают.')
        return validate_password(cd['password2'])

    def save(self, commit=True):
        user = super().save(commit=False)
        user.set_password(self.cleaned_data['password'])
        user.is_active = False
        if commit:
            user.save()
        user_registrated.send(UserRegistrationForm, instance=user)
        return user

users/api/views.py
from django.shortcuts import render

users/views.py
from django.shortcuts import render, get_object_or_404
from django.contrib.auth.views import (LoginView, LogoutView, PasswordChangeView, PasswordResetView,
                                       PasswordResetConfirmView, PasswordResetCompleteView)
from django.contrib.auth.mixins import LoginRequiredMixin
from django.views.generic import CreateView
from django.views.generic.edit import UpdateView
from django.urls import reverse_lazy
from django.core.signing import BadSignature
from django.contrib.messages.views import SuccessMessageMixin


from .forms import *
from .utils import signer
from .models import *


# Create your views here.
class UserLoginView(LoginView):
    redirect_authenticated_user = True
    form_class = CustomUserLoginForm
    template_name = 'users/login.html'


class UserLogoutView(LogoutView):
    next_page = 'purse:index'


class UserChangeInfo(SuccessMessageMixin, LoginRequiredMixin, UpdateView):
    """Изменение данных пользователя"""
    model = CustomUser
    template_name = 'users/change_user_info.html'
    form_class = CustomUserChangeForm
    success_url = reverse_lazy('purse:index')
    success_message = 'Личные данные пользователя обновлены'

    def dispatch(self, request, *args, **kwargs):
        self.user_id = request.user.pk
        return super().dispatch(request, *args, **kwargs)

    def get_object(self, queryset=None):
        if not queryset:
            queryset = self.get_queryset()
        return get_object_or_404(queryset, pk=self.user_id)


class UserPasswordChangeView(SuccessMessageMixin, LoginRequiredMixin, PasswordChangeView):
    """Контроллер смены пароля"""
    template_name = 'users/password_change.html'
    success_url = reverse_lazy('purse:index')
    form_class = CustomUserPasswordChangeForm
    success_message = 'Пароль успешно изменен.'


class UserPasswordResetView(SuccessMessageMixin, PasswordResetView):
    """Контроллер для сброса забытого/утерянного пароля"""
    template_name = 'users/password_reset.html'
    subject_template_name = 'email/reset_subject.txt'
    email_template_name = 'email/reset_email.txt'
    success_url = reverse_lazy('purse:index')
    success_message = 'Письмо со ссылкой для сброса пароля отправлено на указанный email.'
    form_class = CustomUserPasswordResetForm


class UserPasswordResetConfirmView(SuccessMessageMixin, PasswordResetConfirmView):
    """Контроллер для задания нового пароля после сброса"""
    template_name = 'users/password_reset_confirm.html'
    success_url = reverse_lazy('users:password_reset_complete')
    form_class = CustomUserSetNewPasswordForm


class UserPasswordResetCompleteView(PasswordResetCompleteView):
    """Выводит страницу с сообщеием об успешной смене пароля после сброса"""
    template_name = 'users/password_reset_complete.html'


class UserRegistrationView(SuccessMessageMixin, CreateView):
    model = CustomUser
    template_name = 'users/user_registration.html'
    form_class = UserRegistrationForm
    success_url = reverse_lazy('purse:index')
    success_message = 'Пользователь зарегистрирован. Письмо с ссылкой для активации аккаунта отправлено на email, ' \
                      'указанный при регистрации'


def user_activate(request, sign):
    try:
        username = signer.unsign(sign)
    except BadSignature:
        return render(request, 'users/bad_signature.html')
    user = get_object_or_404(CustomUser, email=username)
    if user.is_active:
        template = 'users/user_is_activated.html'
    else:
        template = 'users/activation_done.html'
        user.is_active = True
        user.save()
    return render(request, template)

templates/users/activation_done.html
{% extends 'base.html' %}

{% block title %}Активация выполнена{% endblock %}

{% block content %}

<div class="row mt-3">
    <div class="col-3"></div>
    <div class="col-6">
        <h2>Активация</h2>
        <p>Пользователь успешно активирован.</p>
        <p><a href="{% url 'purse:index' %}" class="btn btn-sm btn-outline-secondary">Войти на сайт</a></p>
    </div>
    <div class="col-3"></div>
</div>

{% endblock %}

templates/users/bad_signature.html
{% extends 'base.html' %}

{% block title %}Ошибка активации{% endblock %}

{% block content %}

<div class="row mt-3">
    <div class="col-3"></div>
    <div class="col-6">
        <h2>Активация</h2>
        <p>Активация пользователя с таким именем прошла неудачно.</p>
        <p><a href="{% url 'users:user_registration' %}">Зарегистрироваться повторно.</a></p>
    </div>
    <div class="col-3"></div>
</div>

{% endblock %}

templates/users/change_user_info.html
{% extends 'base.html' %}
{% load static %}
{% load bootstrap4 %}

{% block title %}Редактирования профиля{% endblock %}

{% block content %}

<div class="row">
    <div class="col-12">
        <div class="jumbotron p-4 p-md-5 text-dark rounded bg-white-50">
            <div class="col-8 px-0">
                <h4 class="display-5 font-italic">Правка личных данных пользователя {{ user.username }}</h4>
                <form class="px-4 py-3 mt-3" method="post" class="mt-3">
                    {% csrf_token %}
                    {% bootstrap_form form layout='horizontal' show_label=True size='small' %}
                    <a href="{% url 'purse:index' %}" class="btn btn-sm btn-outline-secondary mr-2">Отмена</a>
                    {% bootstrap_button 'Сохранить изменения' button_class='btn btn-sm btn-outline-secondary' button_type='submit' size='small' %}
                </form>
            </div>
        </div>
    </div>
</div>


{% endblock %}

templates/users/login.html
{% extends 'base.html' %}
{% load static %}
{% load bootstrap4 %}

{% block title %}Авторизация{% endblock %}

{% block content %}

<div class="row mt-3">
    <div class="col-3"></div>
    <div class="col-6">
        <h3>User authorization</h3>
    </div>
    <div class="col-3"></div>
</div>

<div class="row">
    <div class="col-3"></div>
    <div class="col-6">
        <form method="post">
            {% csrf_token %}
            {% bootstrap_form login_form show_label=False size='small' %}

            <small class="form-text text-muted mt-3">Авторизация с помощью социальных сетей | <a href="{% url 'users:password_reset' %}">Забыли пароль?</a></small>
            <div class="row mt-1">
                <div class="col-1">
                    <a href="{% url 'social:begin' 'vk-oauth2' %}"><img src="{% static 'users/img/vk.png' %}" width="30px" height="30px"></a>
                </div>
                <div class="col-1">
                    <a href="{% url 'social:begin' 'google-oauth2' %}"><img src="{% static 'users/img/google.png' %}" width="30px" height="30px"></a>
                </div>
                <div class="col-1">
                    <a href="{% url 'social:begin' 'github' %}"><img src="{% static 'users/img/github.png' %}" width="30px" height="30px"></a>
                </div>
            </div>

            {% bootstrap_button 'Войти' button_class='btn-info mt-4' button_type='submit' size='small' %}
        </form>
    </div>
    <div class="col-3"></div>
</div>


{% endblock %}

templates/users/oauth2_email_already_exists.html
{% extends 'base.html' %}

{% block content %}

<div class="row">
    <div class="col">
        <a href="{% url 'users:login' %}" class="btn btn-info btn-sm">Log In</a>
        <a href="{% url 'users:password_reset' %}" class="btn btn-info btn-sm">Reset Password</a>
    </div>
</div>

{% endblock %}

templates/users/password_change.html
{% extends 'base.html' %}
{% load bootstrap4 %}

{% block title %}Смена пароля{% endblock %}

{% block content %}

<div class="row">
    <div class="col">
        <div class="jumbotron p-4 p-md-5 text-dark rounded bg-white-50">
            <div class="col-md-6 px-0">
                <h4 class="display-5 font-italic">Смена пароля пользователя {{ user.username }}</h4>
                <form method="post">
                    {% csrf_token %}
                    {% bootstrap_form form layout='horizontal' size='small' label_class='col-md-4 col-form-label' horizontal_field_class='col-md-8' %}
                    <a href="{% url 'purse:index' %}" class="btn btn-sm btn-outline-secondary mr-2">Отмена</a>
                    {% bootstrap_button 'Сменить пароль' button_class='btn btn-sm btn-outline-secondary' button_type='submit' size='small' %}
                </form>
            </div>
        </div>
    </div>
</div>

{% endblock %}

templates/users/password_change_done.html
{% extends 'base.html' %}

{% block title %}Смена пароля{% endblock %}

{% block content %}

<div class="row mt-3">
    <div class="col-3"></div>
    <div class="col-6">
        <h3>Пароль был успешно изменен.</h3>
    </div>
    <div class="col-3"></div>
</div>

{% endblock %}

templates/users/password_reset.html
{% extends 'base.html' %}
{% load bootstrap4 %}

{% block title %}Сброс пароля{% endblock %}

{% block content %}

<div class="row">
    <div class="col">
        <div class="jumbotron p-4 p-md-5 text-secondary rounded bg-white-50">
            <div class="col-8 px-0">
                <div class="row">
                    <div class="col">
                        <h3>Сброс пароля пользователя.</h3>
                    </div>
                </div>
                <div class="row">
                    <div class="col">
                        <form method="post">
                            {% csrf_token %}
                            {% bootstrap_form form layout='horizontal' show_label=False size='small' %}
                            {% bootstrap_button 'Отправить ссылку' button_class='btn btn-sm btn-outline-secondary mt-2' button_type='submit' size='small' %}
                        </form>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>

{% endblock %}

templates/users/password_reset_complete.html
{% extends 'base.html' %}

{% block title %}Смена пароля{% endblock %}

{% block content %}

<div class="row">
    <div class="col">
        <div class="jumbotron p-4 p-md-5 text-secondary rounded bg-white-50">
            <div class="col-8 px-0">
                <div class="row">
                    <div class="col">
                        <h3>Пароль успешно изменен.</h3>
                    </div>
                </div>
                <div class="row">
                    <div class="col">
                        <p>Для продолжения <a href="{% url 'purse:index' %}">авторизуйтесь </a>на сайте с новым паролем.</p>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>

{% endblock %}

templates/users/password_reset_confirm.html
{% extends 'base.html' %}
{% load bootstrap4 %}

{% block title %}Сброс пароля{% endblock %}

{% block content %}


<div class="row">
    <div class="col">
        <div class="jumbotron p-4 p-md-5 text-secondary rounded bg-white-50">
            <div class="col-8 px-0">
                <div class="row">
                    <div class="col">
                        <h3>Создание нового пароля пользователя.</h3>
                    </div>
                </div>
                <div class="row">
                    <div class="col">
                        <form method="post">
                            {% csrf_token %}
                            {% bootstrap_form form layout='horizontal' show_label=False size='small' %}
                            {% bootstrap_button 'Сохранить' button_class='btn btn-sm btn-outline-secondary mt-2' button_type='submit' size='small' %}
                        </form>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>

{% endblock %}

templates/users/user_is_activated.html
{% extends 'base.html' %}

{% block title %}Пользователь уже активирован{% endblock %}

{% block content %}

<div class="row mt-3">
    <div class="col-3"></div>
    <div class="col-6">
        <h3>Активация</h3>
        <p>Пользователь с таким именем был активирован ранее.</p>
        <p><a href="{% url 'purse:index' %}">Войти на сайт.</a></p>
    </div>
    <div class="col-3"></div>
</div>

{% endblock %}

templates/users/user_registration.html
{% extends 'base.html' %}
{% load static %}
{% load bootstrap4 %}

{% block title %}Регистрация{% endblock %}

{% block content %}

<div class="row">
    <div class="col-12">
        <div class="jumbotron p-4 p-md-5 text-dark rounded bg-white-50">
            <div class="col-8 px-0">
                <h4 class="display-5 font-italic">Регистрация нового пользователя</h4>
                <form class="px-4 py-3 mt-3" method="post">
                    {% csrf_token %}
                    {% bootstrap_form form show_label=True size='small' layout='horizontal' %}
                    <small class="form-text text-muted mt-3">Регистрация с помощью социальных сетей | <a
                            href="{% url 'users:password_reset' %}">Забыли пароль?</a></small>
                    <div class="row mt-1">
                        <div class="col-1">
                            <a href="{% url 'social:begin' 'vk-oauth2' %}"><img
                                    src="{% static 'users/img/vk.png' %}" width="30px" height="30px"></a>
                        </div>
                        <div class="col-1">
                            <a href="{% url 'social:begin' 'google-oauth2' %}"><img
                                    src="{% static 'users/img/google.png' %}" width="30px" height="30px"></a>
                        </div>
                        <div class="col-1">
                            <a href="{% url 'social:begin' 'github' %}"><img src="{% static 'users/img/github.png' %}" width="30px" height="30px"></a>
                        </div>
                    </div>
                    <a href="{% url 'purse:index' %}" class="btn btn-sm btn-outline-secondary mr-2 mt-3">Отмена</a>
                    {% bootstrap_button 'Зарегистрироваться' button_class='btn btn-sm btn-outline-secondary mt-3' button_type='submit' size='small' %}
                </form>
            </div>
        </div>
    </div>
</div>

{% endblock %}